html.cgi: improve content support
[girocco.git] / shlib.sh
blob9f22fa49d67df50d5ec3a2bdd2d50f0f3b9d0c10
1 #!/bin/sh
3 # This is generic shell library for all the scripts used by Girocco;
4 # most importantly, it introduces all the $cfg_* shell variables.
6 # SHA-1 pattern
7 octet='[0-9a-f][0-9a-f]'
8 octet4="$octet$octet$octet$octet"
9 octet19="$octet4$octet4$octet4$octet4$octet$octet$octet"
10 octet20="$octet4$octet4$octet4$octet4$octet4"
12 vcmp() {
13 # Compare $1 to $2 each of which must match \d+(\.\d+)*
14 # An empty string ('') for $1 or $2 is treated like 0
15 # Outputs:
16 # -1 if $1 < $2
17 # 0 if $1 = $2
18 # 1 if $1 > $2
19 # Note that `vcmp 1.8 1.8.0.0.0.0` correctly outputs 0.
20 while
21 _a="${1%%.*}"
22 _b="${2%%.*}"
23 [ -n "$_a" -o -n "$_b" ]
25 if [ "${_a:-0}" -lt "${_b:-0}" ]; then
26 echo -1
27 return
28 elif [ "${_a:-0}" -gt "${_b:-0}" ]; then
29 echo 1
30 return
32 _a2="${1#$_a}"
33 _b2="${2#$_b}"
34 set -- "${_a2#.}" "${_b2#.}"
35 done
36 echo 0
39 get_girocco_config_pm_var_list() {
40 # Export all the variables from Girocco::Config to suitable var= lines
41 # prefixing them with 'cfg_'. E.g. $cfg_admin is admin's mail address now
42 # and also setting a 'defined_cfg_' prefix to 1 if they are not undef.
43 __girocco_conf="$GIROCCO_CONF"
44 [ -n "$__girocco_conf" ] || __girocco_conf="Girocco::Config"
45 [ -z "$basedir" ] || __girocco_extrainc="-I$basedir"
46 perl -I@basedir@ $__girocco_extrainc -M$__girocco_conf -le \
47 'foreach (sort {uc($a) cmp uc($b)} keys %Girocco::Config::) {
48 my $val = ${$Girocco::Config::{$_}}; defined($val) or $val="";
49 $val =~ s/([\\"\$\`])/\\$1/gos;
50 $val =~ s/(?:\r\n|\r|\n)$//os;
51 print "cfg_$_=\"$val\"";
52 print "defined_cfg_$_=",
53 (defined(${$Girocco::Config::{$_}})?"1":"");
57 get_girocco_config_var_list() (
58 # Same as get_girocco_config_pm_var_list except that
59 # the following variables (all starting with var_) are added:
60 # var_git_ver The version number part from `git version`
61 # var_have_git_172 Set to 1 if git version >= 1.7.2 otherwise ''
62 # var_window_memory Value to use for repack --window-memory=
63 # var_log_window_size Value to use for git-svn --log-window-size=
64 _cfg_vars="$(get_girocco_config_pm_var_list)"
65 eval "$_cfg_vars"
66 printf '%s\n' "$_cfg_vars"
67 _gver="$("$cfg_git_bin" version 2>/dev/null | \
68 sed -ne 's/^[^0-9]*\([0-9][0-9]*\(\.[0-9][0-9]*\)*\).*$/\1/p')"
69 printf 'var_git_ver=%s\n' "$_gver"
70 printf 'var_have_git_172=%s\n' "$([ $(vcmp "$_gver" 1.7.2) -ge 0 ] && echo 1)"
71 __girocco_conf="$GIROCCO_CONF"
72 [ -n "$__girocco_conf" ] || __girocco_conf="Girocco::Config"
73 [ -z "$basedir" ] || __girocco_extrainc="-I$basedir"
74 printf "var_window_memory=%s\n" \
75 "$(perl -I@basedir@ $__girocco_extrainc -M$__girocco_conf \
76 -MGirocco::Util -e 'print calc_windowmemory')"
77 printf 'var_log_window_size=%s\n' "${cfg_svn_log_window_size:-250}"
80 # If basedir has been replaced, and shlib_vars.sh exists, get the config
81 # definitions from it rather than running Perl.
82 if [ "@basedir@" = '@'basedir'@' ] || ! [ -r "@basedir@/shlib_vars.sh" ]; then
83 # Import all the variables from Girocco::Config to the local environment,
84 eval "$(get_girocco_config_var_list)"
85 else
86 # Import the variables from shlib_vars.sh which avoids needlessly
87 # running another copy of Perl
88 . "@basedir@/shlib_vars.sh"
91 # Make sure we have a reproducible environment by using a controlled HOME dir
92 XDG_CONFIG_HOME="$cfg_chroot/var/empty"
93 HOME="$cfg_chroot/etc/girocco"
94 GIT_CONFIG_NOSYSTEM=1
95 GIT_ATTR_NOSYSTEM=1
96 GIT_NO_REPLACE_OBJECTS=1
97 GIT_TERMINAL_PROMPT=0
98 GIT_ASKPASS="$cfg_basedir/bin/git-askpass-password"
99 export XDG_CONFIG_HOME
100 export HOME
101 export GIT_CONFIG_NOSYSTEM
102 export GIT_ATTR_NOSYSTEM
103 export GIT_NO_REPLACE_OBJECTS
104 export GIT_TERMINAL_PROMPT
105 export GIT_ASKPASS
106 unset GIT_USER_AGENT
107 unset GIT_HTTP_USER_AGENT
108 if [ -n "$defined_cfg_git_client_ua" ]; then
109 GIT_USER_AGENT="$cfg_git_client_ua"
110 export GIT_USER_AGENT
111 GIT_HTTP_USER_AGENT="$cfg_git_client_ua"
112 export GIT_HTTP_USER_AGENT
115 # We cannot use a git() {} or nc_openbsd() {} function to redirect git
116 # and nc_openbsd to the desired executables because when using
117 # "ENV_VAR=xxx func" the various /bin/sh implementations behave in various
118 # different and unexpected ways:
119 # a) treat "ENV_VAR=xxx" like a separate, preceding "export ENV_VAR=xxx"
120 # b) treat "ENV_VAR=xxx" like a separate, prededing "ENV_VAR=xxx"
121 # c) treat "ENV_VAR=xxx" like a temporary setting only while running func
122 # None of these are good. We want a temporary "export ENV_VAR=xxx"
123 # setting only while running func which none of the /bin/sh's do.
125 # Instead we'd like to use an alias that provides the desired behavior without
126 # any of the bad (a), (b) or (c) effects.
128 # However, unfortunately, some of the crazy /bin/sh implementations do not
129 # recognize alias expansions when preceded by variable assignments!
131 # So we are left with git() {} and nc_openbsd() {} functions and in the
132 # case of git() {} we can compensate for (b) and (c) failing to export
133 # but not (a) and (b) persisting the values so the caller will simply
134 # have to beware and explicitly unset any variables that should not persist
135 # beyond the function call itself.
137 git() (
138 [ "${GIT_DIR+set}" = "set" ] && export GIT_DIR
139 [ "${GIT_SSL_NO_VERIFY+set}" = "set" ] && export GIT_SSL_NO_VERIFY
140 [ "${GIT_TRACE_PACKET+set}" = "set" ] && export GIT_TRACE_PACKET
141 [ "${GIT_USER_AGENT+set}" = "set" ] && export GIT_USER_AGENT
142 [ "${GIT_HTTP_USER_AGENT+set}" = "set" ] && export GIT_HTTP_USER_AGENT
143 exec "$cfg_git_bin" "$@"
146 nc_openbsd() { "$cfg_nc_openbsd_bin" "$@"; }
148 _addrlist() {
149 _list=
150 for _addr in "$@"; do
151 [ -z "$_list" ] || _list="$_list, "
152 _list="$_list$_addr"
153 done
154 echo "$_list"
157 _sendmail() {
158 _mailer="${cfg_sendmail_bin:-/usr/sbin/sendmail}"
159 if [ -n "$cfg_sender" ]; then
160 "$_mailer" -i -f "$cfg_sender" "$@"
161 else
162 "$_mailer" -i "$@"
166 mail() {
167 _subject=
168 if [ "$1" = "-s" ]; then
169 shift
170 _subject="$1"
171 shift
174 echo "From: \"$cfg_name\" ($cfg_title) <$cfg_admin>"
175 echo "To: $(_addrlist "$@")"
176 [ -z "$_subject" ] || echo "Subject: $_subject"
177 echo "MIME-Version: 1.0"
178 echo "Content-Type: text/plain; charset=utf-8"
179 echo "Content-Transfer-Encoding: 8bit"
180 echo "Auto-Submitted: auto-generated"
181 echo ""
183 } | _sendmail "$@"
186 # bang CMD... will execute the command with well-defined failure mode;
187 # set bang_action to string of the failed action ('clone', 'update', ...);
188 # pre-set bang_once=1 to make sure jobs banging on a repo repeatedly will
189 # not spam the owner; re-define the bang_trap() function to do custom
190 # cleanup before bailing out
191 bang() {
192 if [ -n "$show_progress" ]; then
193 exec 3>&1
194 errcode=
195 read -r errcode <<-EOT || :
197 exec 4>&3 3>&1 1>&4 4>&-
198 { "$@" 3>&- || echo $? >&3; } 2>&1 | tee -a "$bang_log"
201 exec 3>&-
202 if [ -z "$errcode" ]; then
203 # All right. Cool.
204 return;
206 else
207 if "$@" >>"$bang_log" 2>&1; then
208 # All right. Cool.
209 return;
210 else
211 errcode="$?"
214 if ! [ -e .banged ] || [ -e .bangagain ]; then
215 rm -f .bangagain
216 bangmailok=true
217 ! [ -f HEAD -a -f config -a -d objects ] ||
218 bangmailok="$(GIT_DIR=. git config --bool gitweb.statusupdates 2>/dev/null || echo true)"
219 bangaddrs=''
220 [ "$bangmailok" = "false" -o -z "$mail" ] || bangaddrs="$mail"
221 [ -z "$cfg_admincc" -o "$cfg_admincc" = "0" -o -z "$cfg_admin" ] ||
222 if [ -z "$bangaddrs" ]; then bangaddrs="$cfg_admin"; else bangaddrs="$bangaddrs,$cfg_admin"; fi
223 [ -z "$bangaddrs" ] ||
225 echo "$* failed with error code $errcode"
226 echo ""
227 [ ! -n "$bang_once" ] || echo "you will not receive any more notifications until recovery"
228 echo "this status message may be disabled on the project admin page"
229 echo ""
230 echo "Log follows:"
231 echo ""
232 cat "$bang_log"
233 } | mail -s "[$cfg_name] $proj $bang_action failed" "$bangaddrs"
235 touch .banged
236 cat "$bang_log" > .banglog
237 bang_trap
238 exit 1
241 # bang_eval CMD... will evaluate the command with well-defined failure mode;
242 # Identical to bang CMD... except the command is eval'd instead of executed.
243 bang_eval() {
244 bang eval "$*"
247 # Default bang settings:
248 bang_setup() {
249 bang_action="lame_programmer"
250 bang_once=
251 bang_trap() { :; }
252 bang_log="$(mktemp -t repomgr-XXXXXX)"
253 trap 'rm -f "$bang_log"' EXIT
254 trap 'exit 130' INT
255 trap 'exit 143' TERM
258 # Remove banged status
259 bang_reset() {
260 rm -f .banged .bangagain .banglog
263 # Check to see if banged status
264 is_banged() {
265 [ -e .banged ]
269 # Progress report - if show_progress is set, shows the given message.
270 progress() {
271 [ ! -n "$show_progress" ] || echo "$@"
275 # Project config accessors; must be run in project directory
276 config_get() {
277 git config "gitweb.$1"
280 config_set() {
281 git config "gitweb.$1" "$2" && chgrp repo config && chmod g+w config
284 config_set_raw() {
285 git config "$1" "$2" && chgrp repo config && chmod g+w config
288 config_get_date_seconds() {
289 _dt="$(config_get "$1" || :)"
290 [ -n "$_dt" ] || return 1
291 _ds="$(perl -I@basedir@ -MGirocco::Util -e "print parse_rfc2822_date('$_dt')")"
292 [ -n "$_ds" ] || return 1
293 echo "$_ds"
296 # Tool for checking whether given number of seconds has not passed yet
297 check_interval() {
298 os="$(config_get_date_seconds "$1")" || return 1
299 ns="$(date +%s)"
300 [ $ns -lt $(($os+$2)) ]
304 # List all Git repositories, with given prefix if specified, one-per-line
305 # All project names starting with _ are always excluded from the result
306 get_repo_list() {
307 if [ -n "$1" ]; then
308 cut -d : -f 1,3 "$cfg_chroot"/etc/group | grep "^$1"
309 else
310 cut -d : -f 1,3 "$cfg_chroot"/etc/group
311 fi | while IFS=: read name id; do
312 [ $id -lt 65536 ] || case "$name" in _*) :;; ?*) echo "$name"; esac
313 done
316 # returns empty string for non-mirrors, otherwise one of:
317 # m => normal Git mirror
318 # s => mirror from svn source
319 # d => mirror from darcs source
320 # b => mirror from bzr source
321 # h => mirror from hg source
322 # the optional passed in git dir defaults to "."
323 # will fail if the directory does not have .nofetch and gitweb.baseurl
324 # comes back empty
325 get_mirror_type() {
326 _gitdir="${1:-.}"
327 # always return empty for non-mirrors
328 [ ! -e "$_gitdir/.nofetch" ] || return 0
329 _url="$(GIT_DIR="$_gitdir" config_get baseurl 2>/dev/null || :)"
330 _url="${_url##* }"
331 case "$_url" in
333 return 1
335 svn://* | svn+http://* | svn+https://*)
336 echo 's'
338 darcs://*)
339 echo 'd'
341 bzr://*)
342 echo 'b'
344 hg+http://* | hg+https://*)
345 echo 'h'
348 echo 'm'
350 esac
351 return 0
354 # returns true if the passed in git dir (defaults to ".") is a mirror using git fast-import
355 is_gfi_mirror() {
356 case "$(get_mirror_type "$1" 2>/dev/null || :)" in
357 d|b|h)
358 # darcs, bzr and hg mirrors use git fast-import
359 return 0
362 # Don't think git-svn currently uses git fast-import
363 # And Git mirrors certainly do not
364 return 1
366 esac
367 # assume it does not use git fast-import
368 return 1
371 # returns true if the passed in git dir (defaults to ".") is a mirror using git-svn
372 is_svn_mirror() {
373 [ "$(get_mirror_type "$1" 2>/dev/null || :)" = "s" ]
376 # A well-known UTF-8 locale is required for some of the fast-import providers
377 # in order to avoid mangling characters. Ideally we could use "POSIX.UTF-8"
378 # but that is not reliably UTF-8 but rather usually US-ASCII.
379 # We parse the output of `locale -a` and select a suitable UTF-8 locale.
380 # If we cannot find one in the `locale -a` output then we just use a well-known
381 # UTF-8 locale and hope for the best. We set LC_ALL to our choice and export
382 # it. We only set this temporarily when running the fast-import providers.
383 set_utf8_locale() {
384 _guess_locale="$(locale -a | grep -viE '^(posix|c)(\..*)?$' | \
385 grep -iE '\.utf-?8$' | sed -e 's/\.[Uu][Tt][Ff]-*8$//' | \
386 sed -e '/en_US/ s/^/0 /; /en_US/ !s/^/1 /' | LC_ALL=C sort | \
387 head -n 1 | cut -d ' ' -f 2)"
388 LC_ALL="${_guess_locale:-en_US}.UTF-8"
389 export LC_ALL
392 # hg-fast-export | git fast-import with error handling in current directory GIT_DIR
393 git_hg_fetch() (
394 set_utf8_locale
395 _python="${PYTHON:-python}"
396 _err1=
397 _err2=
398 exec 3>&1
399 { read -r _err1 || :; read -r _err2 || :; } <<-EOT
401 exec 4>&3 3>&1 1>&4 4>&-
403 _e1=0
404 [ -f hg2git-marks ] || touch hg2git-marks
405 _af="$(git config hg.authorsfile || :)"
406 _cmd='GIT_DIR="$(pwd)" "$_python" "$cfg_basedir/bin/hg-fast-export.py" \
407 --repo "$(pwd)/repo.hg" \
408 --marks "$(pwd)/hg2git-marks" \
409 --mapping "$(pwd)/hg2git-mapping" \
410 --heads "$(pwd)/hg2git-heads" \
411 --status "$(pwd)/hg2git-state" \
412 -U unknown --force --flatten --hg-hash'
413 [ -z "$_af" ] || _cmd="$_cmd"' --authors "$_af"'
414 eval "$_cmd" 3>&- || _e1=$?
415 echo $_e1 >&3
416 } | \
418 _e2=0
419 rm -f hg2git-marks.new
420 git fast-import \
421 --export-marks="$(pwd)/hg2git-marks.new" \
422 --export-pack-edges="$(pwd)/gfi-packs" \
423 --force 3>&- || _e2=$?
424 echo $_e2 >&3
428 exec 3>&-
429 [ "$_err1" = 0 -a "$_err2" = 0 ] || return 1
430 if [ -f hg2git-marks ]; then
431 rm -f hg2git-marks.old
432 mv hg2git-marks hg2git-marks.old
433 else
434 touch hg2git-marks.old
436 cat hg2git-marks.old hg2git-marks.new | \
437 LC_ALL=C sort -t : -k2,2n -u | \
438 sed -ne "/^:[1-9][0-9]* $octet20\$/p" > hg2git-marks
439 rm hg2git-marks.old hg2git-marks.new
440 rm -f hg2git-heads
441 git branch --no-color | \
442 while IFS= read -r _head; do
443 echo ":${_head#??} $(git rev-parse "refs/heads/${_head#??}")"
444 done > hg2git-heads